# Module `Escort`

Taking the lead of AI escorting your flight.

# #ESCORT class

The #ESCORT class allows you to interact with escorting AI on your flight and take the lead. Each escorting group can be commanded with a whole set of radio commands (radio menu in your flight, and then F10).

The radio commands will vary according the category of the group. The richest set of commands are with Helicopters and AirPlanes. Ships and Ground troops will have a more limited set, but they can provide support through the bombing of targets designated by the other escorts.

# RADIO MENUs that can be created:

Find a summary below of the current available commands:

## Navigation ...:

Escort group navigation functions:

- "Join-Up and Follow at x meters": The escort group fill follow you at about x meters, and they will follow you.
- "Flare": Provides menu commands to let the escort group shoot a flare in the air in a color.
- "Smoke": Provides menu commands to let the escort group smoke the air in a color. Note that smoking is only available for ground and naval troops.

## Hold position ...:

Escort group navigation functions:

- "At current location": Stops the escort group and they will hover 30 meters above the ground at the position they stopped.
- "At client location": Stops the escort group and they will hover 30 meters above the ground at the position they stopped.

## Report targets ...:

Report targets will make the escort group to report any target that it identifies within a 8km range. Any detected target can be attacked using the 4. Attack nearby targets function. (see below).

- "Report now": Will report the current detected targets.
- "Report targets on": Will make the escort group to report detected targets and will fill the "Attack nearby targets" menu list.
- "Report targets off": Will stop detecting targets.

## Scan targets ...:

Menu items to pop-up the escort group for target scanning. After scanning, the escort group will resume with the mission or defined task.

- "Scan targets 30 seconds": Scan 30 seconds for targets.
- "Scan targets 60 seconds": Scan 60 seconds for targets.

## Attack targets ...:

This menu item will list all detected targets within a 15km range. Depending on the level of detection (known/unknown) and visuality, the targets type will also be listed.

## Request assistance from ...:

This menu item will list all detected targets within a 15km range, as with the menu item Attack Targets. This menu item allows to request attack support from other escorts supporting the current client group. eg. the function allows a player to request support from the Ship escort to attack a target identified by the Plane escort with its Tomahawk missiles. eg. the function allows a player to request support from other Planes escorting to bomb the unit with illumination missiles or bombs, so that the main plane escort can attack the area.

## ROE ...:

Sets the Rules of Engagement (ROE) of the escort group when in flight.

- "Hold Fire": The escort group will hold fire.
- "Return Fire": The escort group will return fire.
- "Open Fire": The escort group will open fire on designated targets.
- "Weapon Free": The escort group will engage with any target.

## Evasion ...:

Will define the evasion techniques that the escort group will perform during flight or combat.

- "Fight until death": The escort group will have no reaction to threats.
- "Use flares, chaff and jammers": The escort group will use passive defense using flares and jammers. No evasive manoeuvres are executed.
- "Evade enemy fire": The rescort group will evade enemy fire before firing.
- "Go below radar and evade fire": The escort group will perform evasive vertical manoeuvres.

## Resume Mission ...:

Escort groups can have their own mission. This menu item will allow the escort group to resume their Mission from a given waypoint. Note that this is really fantastic, as you now have the dynamic of taking control of the escort groups, and allowing them to resume their path or mission.

# ESCORT construction methods.

Create a new SPAWN object with the ESCORT.New method:

- ESCORT.New: Creates a new ESCORT object from a Group#GROUP for a Client#CLIENT, with an optional briefing text.

# ESCORT initialization methods.

The following menus are created within the RADIO MENU of an active unit hosted by a player:

- ESCORT.MenuFollowAt: Creates a menu to make the escort follow the client.
- ESCORT.MenuHoldAtEscortPosition: Creates a menu to hold the escort at its current position.
- ESCORT.MenuHoldAtLeaderPosition: Creates a menu to hold the escort at the client position.
- ESCORT.MenuScanForTargets: Creates a menu so that the escort scans targets.
- ESCORT.MenuFlare: Creates a menu to disperse flares.
- ESCORT.MenuSmoke: Creates a menu to disparse smoke.
- ESCORT.MenuReportTargets: Creates a menu so that the escort reports targets.
- ESCORT.MenuReportPosition: Creates a menu so that the escort reports its current position from bullseye.
- ESCORT.MenuAssistedAttack: Creates a menu structure so that the escort can resume from a waypoint.

## Global(s)

ESCORT |
_Resume(EscortGroup) |

## Type `ESCORT`

ESCORT.ClassName |
ESCORT.EscortClient |
ESCORT.EscortGroup |
ESCORT.EscortMenuAttackNearbyTargets |
ESCORT.EscortMenuEvasion |
ESCORT.EscortMenuEvasionEvadeFire |
ESCORT.EscortMenuEvasionNoReaction |
ESCORT.EscortMenuEvasionPassiveDefense |
ESCORT.EscortMenuFlare |
ESCORT.EscortMenuFlareGreen |
ESCORT.EscortMenuFlareRed |
ESCORT.EscortMenuFlareWhite |
ESCORT.EscortMenuFlareYellow |
ESCORT.EscortMenuHold |
ESCORT.EscortMenuHoldAtLeaderPosition |
ESCORT.EscortMenuHoldPosition |
ESCORT.EscortMenuJoinUpAndFollow |
ESCORT.EscortMenuOptionEvasionVertical |
ESCORT.EscortMenuROE |
ESCORT.EscortMenuROEHoldFire |
ESCORT.EscortMenuROEOpenFire |
ESCORT.EscortMenuROEReturnFire |
ESCORT.EscortMenuROEWeaponFree |
ESCORT.EscortMenuReportNavigation |
ESCORT.EscortMenuReportNearbyTargets |
ESCORT.EscortMenuReportNearbyTargetsNow |
ESCORT.EscortMenuReportNearbyTargetsOff |
ESCORT.EscortMenuReportNearbyTargetsOn |
ESCORT.EscortMenuResumeMission |
ESCORT.EscortMenuScan |
ESCORT.EscortMenuScanForTargets |
ESCORT.EscortMenuSmoke |
ESCORT.EscortMenuSmokeBlue |
ESCORT.EscortMenuSmokeGreen |
ESCORT.EscortMenuSmokeOrange |
ESCORT.EscortMenuSmokeRed |
ESCORT.EscortMenuSmokeWhite |
ESCORT.EscortMenuTargetAssistance |
ESCORT.EscortMode | The mode the escort is in.
ESCORT.EscortName |
ESCORT.FollowScheduler | The id of the _FollowScheduler function.
ESCORT:JoinUpAndFollow(EscortGroup, EscortClient, Distance) | JoinsUp and Follows a CLIENT.
ESCORT.MODE |
ESCORT:MenuAssistedAttack() | Defines a menu slot to let the escort attack its detected targets using assisted attack from another escort joined also with the client.
ESCORT:MenuEvasion(MenuTextFormat) | Defines a menu to let the escort set its evasion when under threat.
ESCORT:MenuFlare(MenuTextFormat) | Defines a menu slot to let the escort disperse a flare in a certain color.
ESCORT:MenuFollowAt(Distance) | Defines a menu slot to let the escort Join and Follow you at a certain distance.
ESCORT:MenuHoldAtEscortPosition(Height, Seconds, MenuTextFormat) | Defines a menu slot to let the escort hold at their current position and stay low with a specified height during a specified time in seconds.
ESCORT:MenuHoldAtLeaderPosition(Height, Seconds, MenuTextFormat) | Defines a menu slot to let the escort hold at the client position and stay low with a specified height during a specified time in seconds.
ESCORT:MenuROE(MenuTextFormat) | Defines a menu to let the escort set its rules of engagement.
ESCORT:MenuReportTargets(Seconds) | Defines a menu slot to let the escort report their current detected targets with a specified time interval in seconds.
ESCORT:MenuResumeMission() | Defines a menu to let the escort resume its mission from a waypoint on its route.
ESCORT:MenuScanForTargets(Height, Seconds, MenuTextFormat) | Defines a menu slot to let the escort scan for targets at a certain height for a certain time in seconds.
ESCORT:MenuSmoke(MenuTextFormat) | Defines a menu slot to let the escort disperse a smoke in a certain color.
ESCORT:Menus() | Defines the default menus
ESCORT:New(EscortClient, EscortGroup, EscortName, EscortBriefing) | ESCORT class constructor for an AI group
ESCORT.OptionROE |
ESCORT.OptionReactionOnThreat | Which REACTIONONTHREAT is set to the EscortGroup.
ESCORT:RegisterRoute() | Registers the waypoints
ESCORT.ReportTargets | If true, nearby targets are reported.
ESCORT.ReportTargetsScheduler |
ESCORT.Targets |
ESCORT.TaskPoints |
ESCORT._AssistTarget(MenuParam) |
ESCORT._AttackTarget(MenuParam) |
ESCORT._Flare(MenuParam) |
ESCORT:_FollowScheduler(FollowDistance) |
ESCORT._HoldPosition(MenuParam) |
ESCORT._JoinUpAndFollow(MenuParam) |
ESCORT._ROE(MenuParam) |
ESCORT._ROT(MenuParam) |
ESCORT._ReportNearbyTargetsNow(MenuParam) |
ESCORT:_ReportTargetsScheduler() | Report Targets Scheduler.
ESCORT._ResumeMission(MenuParam) |
ESCORT._ScanTargets(MenuParam) |
ESCORT._Smoke(MenuParam) |
ESCORT._SwitchReportNearbyTargets(MenuParam) |

## Type `ESCORT.MODE`

ESCORT.MODE.FOLLOW |
ESCORT.MODE.MISSION |

## Type `MENUPARAM`

MENUPARAM.ParamDistance |
MENUPARAM.ParamFunction |
MENUPARAM.ParamMessage |
MENUPARAM.ParamSelf |

## Global(s)

#ESCORT ESCORT

_Resume(EscortGroup)

  ### Parameter

  - `EscortGroup` :

## Type `Escort`

## Type `Distance`

## Type `ESCORT`

### Field(s)

#string ESCORT.ClassName

Client#CLIENT ESCORT.EscortClient

Group#GROUP ESCORT.EscortGroup

ESCORT.EscortMenuAttackNearbyTargets

  Attack Targets

ESCORT.EscortMenuEvasion

  Reaction to Threats

ESCORT.EscortMenuEvasionEvadeFire

ESCORT.EscortMenuEvasionNoReaction

ESCORT.EscortMenuEvasionPassiveDefense

ESCORT.EscortMenuFlare

ESCORT.EscortMenuFlareGreen

ESCORT.EscortMenuFlareRed

ESCORT.EscortMenuFlareWhite

ESCORT.EscortMenuFlareYellow

ESCORT.EscortMenuHold

ESCORT.EscortMenuHoldAtLeaderPosition

ESCORT.EscortMenuHoldPosition

ESCORT.EscortMenuJoinUpAndFollow

ESCORT.EscortMenuOptionEvasionVertical

ESCORT.EscortMenuROE

  Rules of Engagement

ESCORT.EscortMenuROEHoldFire

ESCORT.EscortMenuROEOpenFire

ESCORT.EscortMenuROEReturnFire

ESCORT.EscortMenuROEWeaponFree

ESCORT.EscortMenuReportNavigation

ESCORT.EscortMenuReportNearbyTargets

ESCORT.EscortMenuReportNearbyTargetsNow

  Report Targets

ESCORT.EscortMenuReportNearbyTargetsOff

ESCORT.EscortMenuReportNearbyTargetsOn

Menu#MENU_CLIENT ESCORT.EscortMenuResumeMission

ESCORT.EscortMenuScan

ESCORT.EscortMenuScanForTargets

ESCORT.EscortMenuSmoke

ESCORT.EscortMenuSmokeBlue

ESCORT.EscortMenuSmokeGreen

ESCORT.EscortMenuSmokeOrange

ESCORT.EscortMenuSmokeRed

ESCORT.EscortMenuSmokeWhite

ESCORT.EscortMenuTargetAssistance

  Request assistance from other escorts. This is very useful to let f.e. an escorting ship attack a target detected by an escorting plane...

#ESCORT.MODE ESCORT.EscortMode

  The mode the escort is in.

#string ESCORT.EscortName

#number ESCORT.FollowScheduler

  The id of the _FollowScheduler function.

ESCORT:JoinUpAndFollow(EscortGroup, EscortClient, Distance)

  JoinsUp and Follows a CLIENT.

  ### Parameters

  - `Group#GROUP EscortGroup` :

  - `Client#CLIENT EscortClient` :

  - `DCSTypes#Distance Distance` :

ESCORT.MODE

ESCORT:MenuAssistedAttack()

  Defines a menu slot to let the escort attack its detected targets using assisted attack from another escort joined also with the client.

  This menu will appear under Request assistance from. Note that this method needs to be preceded with the method MenuReportTargets.

  ### Return value

  #ESCORT:

ESCORT:MenuEvasion(MenuTextFormat)

  Defines a menu to let the escort set its evasion when under threat.

  All rules of engagement will appear under the menu Evasion.

  ### Parameter

  - `MenuTextFormat` :

  ### Return value

  #ESCORT:

ESCORT:MenuFlare(MenuTextFormat)

  Defines a menu slot to let the escort disperse a flare in a certain color.

  This menu will appear under Navigation. The flare will be fired from the first unit in the group.

  ### Parameter

  - `#string MenuTextFormat` : Optional parameter that shows the menu option text. If no text is given, the default text will be displayed.

  ### Return value

  #ESCORT:

ESCORT:MenuFollowAt(Distance)

  Defines a menu slot to let the escort Join and Follow you at a certain distance.

  This menu will appear under Navigation.

  ### Parameter

  - `DCSTypes#Distance Distance` : The distance in meters that the escort needs to follow the client.

  ### Return value

  #ESCORT:

ESCORT:MenuHoldAtEscortPosition(Height, Seconds, MenuTextFormat)

  Defines a menu slot to let the escort hold at their current position and stay low with a specified height during a specified time in seconds.

  This menu will appear under Hold position.

  ### Parameters

  - `DCSTypes#Distance Height` : Optional parameter that sets the height in meters to let the escort orbit at the current location. The default value is 30 meters.

  - `DCSTypes#Time Seconds` : Optional parameter that lets the escort orbit at the current position for a specified time. (not implemented yet). The default value is 0 seconds, meaning, that the escort will orbit forever until a sequent command is given.

  - `#string MenuTextFormat` : Optional parameter that shows the menu option text. The text string is formatted, and should contain two %d tokens in the string. The first for the Height, the second for the Time (if given). If no text is given, the default text will be displayed.

  ### Return value

  #ESCORT: TODO: Implement Seconds parameter. Challenge is to first develop the "continue from last activity" function.

ESCORT:MenuHoldAtLeaderPosition(Height, Seconds, MenuTextFormat)

  Defines a menu slot to let the escort hold at the client position and stay low with a specified height during a specified time in seconds.

  This menu will appear under Navigation.

  ### Parameters

  - `DCSTypes#Distance Height` : Optional parameter that sets the height in meters to let the escort orbit at the current location. The default value is 30 meters.

  - `DCSTypes#Time Seconds` : Optional parameter that lets the escort orbit at the current position for a specified time. (not implemented yet). The default value is 0 seconds, meaning, that the escort will orbit forever until a sequent command is given.

  - `#string MenuTextFormat` : Optional parameter that shows the menu option text. The text string is formatted, and should contain one or two %d tokens in the string. The first for the Height, the second for the Time (if given). If no text is given, the default text will be displayed.

  ### Return value

  #ESCORT: TODO: Implement Seconds parameter. Challenge is to first develop the "continue from last activity" function.

ESCORT:MenuROE(MenuTextFormat)

  Defines a menu to let the escort set its rules of engagement.

  All rules of engagement will appear under the menu ROE.

  ### Parameter

  - `MenuTextFormat` :

  ### Return value

  #ESCORT:

ESCORT:MenuReportTargets(Seconds)

  Defines a menu slot to let the escort report their current detected targets with a specified time interval in seconds.

  This menu will appear under Report targets. Note that if a report targets menu is not specified, no targets will be detected by the escort, and the attack and assisted attack menus will not be displayed.

  ### Parameter

  - `DCSTypes#Time Seconds` : Optional parameter that lets the escort report their current detected targets after specified time interval in seconds. The default time is 30 seconds.

  ### Return value

  #ESCORT:

ESCORT:MenuResumeMission()

  Defines a menu to let the escort resume its mission from a waypoint on its route.

  All rules of engagement will appear under the menu Resume mission from.

  ### Return value

  #ESCORT:

ESCORT:MenuScanForTargets(Height, Seconds, MenuTextFormat)

  Defines a menu slot to let the escort scan for targets at a certain height for a certain time in seconds.

  This menu will appear under Scan targets.

  ### Parameters

  - `DCSTypes#Distance Height` : Optional parameter that sets the height in meters to let the escort orbit at the current location. The default value is 30 meters.

  - `DCSTypes#Time Seconds` : Optional parameter that lets the escort orbit at the current position for a specified time. (not implemented yet). The default value is 0 seconds, meaning, that the escort will orbit forever until a sequent command is given.

  - `#string MenuTextFormat` : Optional parameter that shows the menu option text. The text string is formatted, and should contain one or two %d tokens in the string. The first for the Height, the second for the Time (if given). If no text is given, the default text will be displayed.

  ### Return value

  #ESCORT:

ESCORT:MenuSmoke(MenuTextFormat)

  Defines a menu slot to let the escort disperse a smoke in a certain color.

  This menu will appear under Navigation. Note that smoke menu options will only be displayed for ships and ground units. Not for air units. The smoke will be fired from the first unit in the group.

  ### Parameter

  - `#string MenuTextFormat` : Optional parameter that shows the menu option text. If no text is given, the default text will be displayed.

  ### Return value

  #ESCORT:

ESCORT:Menus()

  Defines the default menus

  ### Return value

  #ESCORT:

ESCORT:New(EscortClient, EscortGroup, EscortName, EscortBriefing)

  ESCORT class constructor for an AI group

  ### Parameters

  - `Client#CLIENT EscortClient` : The client escorted by the EscortGroup.

  - `Group#GROUP EscortGroup` : The group AI escorting the EscortClient.

  - `#string EscortName` : Name of the escort.

  - `EscortBriefing` :

  ### Return value

  #ESCORT: self

ESCORT.OptionROE

DCSTypes#AI.Option.Air.val.REACTION_ON_THREAT ESCORT.OptionReactionOnThreat

  Which REACTIONONTHREAT is set to the EscortGroup.

ESCORT:RegisterRoute()

  Registers the waypoints

  ### Return value

  #table:

#boolean ESCORT.ReportTargets

  If true, nearby targets are reported.

ESCORT.ReportTargetsScheduler

ESCORT.Targets

ESCORT.TaskPoints

ESCORT._AssistTarget(MenuParam)

  ### Parameter

  - `#MENUPARAM MenuParam` :

ESCORT._AttackTarget(MenuParam)

  ### Parameter

  - `#MENUPARAM MenuParam` :

ESCORT._Flare(MenuParam)

  ### Parameter

  - `#MENUPARAM MenuParam` :

ESCORT:_FollowScheduler(FollowDistance)

  ### Parameter

  - `FollowDistance` :

ESCORT._HoldPosition(MenuParam)

  ### Parameter

  - `#MENUPARAM MenuParam` :

ESCORT._JoinUpAndFollow(MenuParam)

  ### Parameter

  - `#MENUPARAM MenuParam` :

ESCORT._ROE(MenuParam)

  ### Parameter

  - `#MENUPARAM MenuParam` :

ESCORT._ROT(MenuParam)

  ### Parameter

  - `#MENUPARAM MenuParam` :

ESCORT._ReportNearbyTargetsNow(MenuParam)

  ### Parameter

  - `#MENUPARAM MenuParam` :

ESCORT:_ReportTargetsScheduler()

  Report Targets Scheduler.

ESCORT._ResumeMission(MenuParam)

  ### Parameter

  - `#MENUPARAM MenuParam` :

ESCORT._ScanTargets(MenuParam)

  ### Parameter

  - `#MENUPARAM MenuParam` :

ESCORT._Smoke(MenuParam)

  ### Parameter

  - `#MENUPARAM MenuParam` :

ESCORT._SwitchReportNearbyTargets(MenuParam)

  ### Parameter

  - `MenuParam` :

## Type `ESCORT.MODE`

ESCORT.Mode class

### Field(s)

#number ESCORT.MODE.FOLLOW

#number ESCORT.MODE.MISSION

## Type `MENUPARAM`

MENUPARAM type

### Field(s)

#Distance MENUPARAM.ParamDistance

#function MENUPARAM.ParamFunction

#string MENUPARAM.ParamMessage

#ESCORT MENUPARAM.ParamSelf